function [kp tauI tauD tauL] = PIDMatrix2Param(Ak,Ck,Dk)
%% Converting PID matrix parameterisation to regular PID values
for k=1:length(Dk)
    k1(k) = -Ak(2*k,2*k);
    k2(k) = Ck(k,(2*k)-1);
    k3(k) = Ck(k,2*k);
    k4(k) = Dk(k,k);
end

for k=1:length(Dk)
    kp(k) = (k3(k)+k4(k)*k1(k))/k1(k);
    tauL(k) = 1/k1(k);
    tauI(k) = (k3(k)+k4(k)*k1(k))/k2(k);
    tauD(k) = k4(k)/(k3(k)+k4(k)*k1(k));
end