% Initialize the LMI
% |A'X+XA XB C'|
% |  B'X  -I D'| <1
% |  C    D  -I|
% 
% X>0

% A,B,C,D - the state space representation of the closed loop system
function [valgamma valX] = brlSyst(Acl,Bcl,Cclu,Cclgamma,Dclgamma)

[Dclrow Dclcol] = size(Dclgamma);

setlmis([]);
[gamma,kn,sgamma] = lmivar(1,[1 0]);
[X,kn,sX] = lmivar(1,[length(Acl) 1]);

% 1st LMI
BRL = newlmi; %LMI form the Bounded Real Lemma
lmiterm([BRL 1 1 X],1,Acl,'s') % Acl'X+XAcl
lmiterm([BRL 2 1 X],Bcl',1);
lmiterm([BRL 2 2 0],-eye(Dclcol));
lmiterm([BRL 3 1 gamma],Cclgamma,1);
lmiterm([BRL 3 1 0],Cclu);
lmiterm([BRL 2 3 gamma],1,Dclgamma');
lmiterm([BRL 3 3 0],-eye(Dclrow));

% 2nd LMI
Xpos = newlmi;
lmiterm([-Xpos 1 1 X],1,1);

% 3nd LMI

gammapos = newlmi;
lmiterm([-gammapos 1 1 gamma],1,1);

lmisys = getlmis;
ndec = decnbr(lmisys);
c = zeros(ndec,1);

gamma1 = 0;
i =1; 
while gamma1==0
  [gamma1 V] = defcx(lmisys,i,gamma,X);  
end
c(i) = -1;
clear i;
% M hente ut en feasable lsning som startpunkt for mincx. Hvis ikke, blir
% mincx infeaseble.

[copt,xopt] = feasp(lmisys);
[copt,xopt] = mincx(lmisys,c,[],xopt);

valX = dec2mat(lmisys,xopt,X);
valgamma = dec2mat(lmisys,xopt,gamma);

    