clear all;
% Initialize the LMI
% |A'X+XA XB C'|
% |  B'X  -I D'| <1
% |  C    D  -I|
% 
% X>0

% A,B,C,D - the state space representation of the closed loop system
% function lmisys = brlinit(A,B,C,D)
% 
% n = size(A);
% 
 setlmis([]);

Bki = [0;1];
loopno = 4;
for k = 1:loopno 
    [aki,kn,saki] = lmivar(1,[1 0]);
    [Aki,kn,sAki] = lmivar(3,[0,1;0,-saki]);
    if k==1
        [Ak,kn,sAk] = lmivar(3,[sAki,zeros(2,2*(loopno-k))]);
        Bk = [Bki zeros(2,loopno-k)];
    end
    if k~=1 && k~=loopno
        [Ak,kn,sAk] = lmivar(3,[sAk;zeros(2,(2*(k-1))),sAki,zeros(2,2*(loopno-k))]);
        Bk = [Bk; zeros(2,k-1) Bki zeros(2,loopno-k)];
    end
    if k==loopno
        [Ak,kn,sAk] = lmivar(3,[sAk;zeros(2,2*(loopno-1)),sAki]);
        Bk = [Bk;zeros(2,loopno-1) Bki];
    end
end


for k = 1:loopno 
    [Cki,kn,sCki] = lmivar(2,[1 2]);
    if k==1
        [Ck,kn,sCk] = lmivar(3,[sCki,zeros(1,2*(loopno-k))]);
    end
    if k~=1 && k~=loopno
        [Ck,kn,sCk] = lmivar(3,[sCk;zeros(1,(2*(k-1))),sCki,zeros(1,2*(loopno-k))]);
    end
    if k==loopno
      [Ck,kn,sCk] = lmivar(3,[sCk;zeros(1,2*(loopno-1)),sCki]);
    end
end

for k = 1:loopno 
    [Dki,kn,sDki] = lmivar(1,[1 0]);
    if k==1
        [Dk,kn,sDk] = lmivar(3,[sDki,zeros(1,loopno-k)]);
    end
    if k~=1 && k~=loopno
    [Dk,kn,sDk] = lmivar(3,[sDk;zeros(1,k-1),sDki,zeros(1,loopno-k)]);
    end
    if k==loopno
      [Dk,kn,sDk] = lmivar(3,[sDk;zeros(1,loopno-1),sDki]);
    end
end

[X,kn,sX] = lmivar(1,[6 1]);

% 1st LMI
% BRL = newlmi; %LMI form the Bounded Real Lemma
% limterm([BRL 1 1 X],A',1); % A'X
% limterm([BRL 1 1 X],A,1);  % XA
% limterm([BRL 1 2 X],1,B);
% limterm([BRL 1 3 0],C');
% limterm([BRL 2 2 0],-1);
% limterm([BRL 2 3 0],D');
% limterm([BRL 3 3 0],-1);
% 
% % 2nd LMI
% Xpos = newlmi;
% lmiterm([-Xpos 1 1 X],1,1);
% 
% lmisys = getlmis;