% Startpunkt for kontrollverdier
%% SIMC settings for start values with BLT
% SIMCindTunBLT;
% 
% kp1 = KcSIMC1;
% tauI1 = tauISIMC1; 
% tauD1 = tauDSIMC1; 
% 
% kp2 = KcSIMC2;
% tauI2 = tauISIMC2;
% tauD2 = tauDSIMC2;
% 
% tauL1 = tauL1;
% tauL2 = tauL2;
%% SIMC settings for start values
% SIMCindTun;
% 
% kp1 = KcSIMC1;
% tauI1 = tauISIMC1; 
% tauD1 = tauDSIMC1; 
% 
% kp2 = KcSIMC2;
% tauI2 = tauISIMC2;
% tauD2 = tauDSIMC2;
% 
% tauL1 = tauL1;
% tauL2 = tauL2;

%% Optimal PID parameters found in Bao
% kp1 = -11.25;
% tauI1 = 46571.70; 
% tauD1 = 8.2e-10; 
% tauL1 = 1e-5;
% 
% kp2 = 15.49;
% tauI2 = 3.87;
% tauD2 = 2.27e-7;
% tauL2 = 1.22e-5;
% Kontrollparametere dobbeltsjekket
%% Almost optimal PID parameters found in Bao
kp1 = -12;
tauI1 = 4600; 
tauD1 = 9e-10; 
tauL1 = 2e-5;

kp2 = 14;
tauI2 = 4;
tauD2 = 3e-7;
tauL2 = 2e-5;
% Kontrollparametere dobbeltsjekket

%% Parameterisation to state space representation
k11 = 1/tauL1;
k12 = 1/tauL2;
k21 = kp1/(tauI1*tauL1);
k22 = kp2/(tauI2*tauL2);
k31 = (kp1/tauL1)*(1-(tauD1/tauL1));
k32 = (kp2/tauL2)*(1-(tauD2/tauL2));
k41 = kp1*(tauD1/tauL1);
k42 = kp2*(tauD2/tauL2);
% Parametrisering dobbeltsjekket

%% Making the transfer functions to the Multi-loop PID
kPID1 = kp1*(1+(1/(tauI1*s))+(tauD1*s))*(1/((tauL1*s)+1));
kPID2 = kp2*(1+(1/(tauI2*s))+(tauD2*s))*(1/((tauL2*s)+1));

KPID = [kPID1  0;
          0  kPID2];

Ak1 = [0 1;0 -k11];
Ak2 = [0 1;0 -k12];
Bki = [0;1];
Ck1 = [k21 k31];
Ck2 = [k22 k32];
Dk1 = k41;
Dk2 = k42;
% Submatriser dobbeltsjekket

Ak = [Ak1 zeros(size(Ak2));
      zeros(size(Ak2)) Ak2];

Bk = [Bki zeros(size(Bki));
      zeros(size(Bki)) Bki];

Ck = [Ck1 zeros(size(Ck2));
      zeros(size(Ck1)) Ck2];
  
Dk = [Dk1 zeros(size(Dk2));
      zeros(size(Dk1)) Dk2];
% Kontrollmatriser dobbeltsjekket
% Kontrollmatrisene korekte i henhold til ss(KPID) realisasjon av KPID
