% Initialize the LMI
% |A'X+XA XB C'|
% |  B'X  -I D'| <1
% |  C    D  -I|
% 
% X>0

% A,B,C,D - the state space representation of the closed loop system
% function lmisys = brlinit(A,B,C,D)
% 
% n = size(A);
% clear all
% 
% Acl = [-1 2;1 -3];
% a2 = [-0.8 1.5;1.3 2.7];
% a3 = [-1.4 0.9;0.7 -2.0];


% 
 setlmis([]);

[X,kn,sX] = lmivar(1,[length(Acl) 1]);

% [X,kn,sX] = lmivar(1,[2 1]);

% 1st LMI
BRL = newlmi; %LMI form the Bounded Real Lemma
lmiterm([BRL 1 1 X],1,Acl,'s') % Acl'X+XAcl
lmiterm([BRL 1 2 X],1,Bcl);
lmiterm([BRL 1 3 0],Ccl');
lmiterm([BRL 2 2 0],-1);
lmiterm([BRL 2 3 0],Dcl');
lmiterm([BRL 3 3 0],-1);

% 2nd LMI
Xpos = newlmi;
lmiterm([-Xpos 1 1 X],1,1);

lmisys = getlmis;

[tmin xfeas] = feasp(lmisys);


    