% Initialize the LMI
% |A'X+XA XB C'|
% |  B'X  -I D'| <1
% |  C    D  -I|
% 
% X>0

% A,B,C,D - the state space representation of the closed loop system
% function [valgamma valX] = brlSyst(Acl,Bcl,Cclu,Cclgamma,Dclgamma)

% [Dclrow Dclcol] = size(Dclgamma);

setlmis([]);
[gamma,kn,sgamma] = lmivar(1,[1 0]);

[X11,kn,sX11] = lmivar(1,[8 1]);
[X12,kn,sX12] = lmivar(2,[8 2]);
[X13,kn,sX13] = lmivar(2,[8 2]);
[X14,kn,sX14] = lmivar(2,[8 4]);

[X21,kn,sX21] = lmivar(3,sX12');
[X22,kn,sX22] = lmivar(1,[2 1]);
[X23,kn,sX23] = lmivar(2,[2 2]);
[X24,kn,sX24] = lmivar(2,[2 4]);

[X31,kn,sX31] = lmivar(3,sX13');
[X32,kn,sX32] = lmivar(3,sX23');
[X33,kn,sX33] = lmivar(1,[2 1]);
[X34,kn,sX34] = lmivar(2,[2 4]);

[X41,kn,sX41] = lmivar(3,sX14');
[X42,kn,sX42] = lmivar(3,sX24');
[X43,kn,sX43] = lmivar(3,sX34');
[X44,kn,sX44] = lmivar(1,[4 1]);

[X,kn,sX] = lmivar(3,[sX11,sX12,sX13,sX14;sX21,sX22,sX23,sX24;sX31,sX32,sX33,sX34;sX41,sX42,sX43,sX44])




% % 1st LMI
% BRL = newlmi; %LMI form the Bounded Real Lemma
% lmiterm([BRL 1 1 X],1,Acl,'s') % Acl'X+XAcl
% lmiterm([BRL 2 1 X],Bcl',1);
% lmiterm([BRL 2 2 0],-eye(Dclcol));
% lmiterm([BRL 3 1 gamma],Cclgamma,1);
% lmiterm([BRL 3 1 0],Cclu);
% lmiterm([BRL 2 3 gamma],1,Dclgamma');
% lmiterm([BRL 3 3 0],-eye(Dclrow));
% 
% % 2nd LMI
% Xpos = newlmi;
% lmiterm([-Xpos 1 1 X],1,1);
% 
% % 3nd LMI
% 
% gammapos = newlmi;
% lmiterm([-gammapos 1 1 gamma],1,1);
% 
% lmisys = getlmis;
% ndec = decnbr(lmisys);
% c = zeros(ndec,1);
% 
% gamma1 = 0;
% i =1; 
% while gamma1==0
%   [gamma1 V] = defcx(lmisys,i,gamma,X);  
% end
% c(i) = -1;
% clear i;
% % M hente ut en feasable lsning som startpunkt for mincx. Hvis ikke, blir
% % mincx infeaseble.
% 
% [copt,xopt] = feasp(lmisys);
% [copt,xopt] = mincx(lmisys,c,[],xopt);
% 
% valX = dec2mat(lmisys,xopt,X);
% valgamma = dec2mat(lmisys,xopt,gamma);

    